Index: palm/trunk/SOURCE/pmc_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface.f90	(revision 1796)
+++ palm/trunk/SOURCE/pmc_interface.f90	(revision 1797)
@@ -1392,285 +1440,317 @@
                       lcr(0:ncorr-1) = 1.0_wp
                    ENDIF
+
 !
 !--                Wall for u on the north side, but not on the south side
                    i  = 0
-!--                TO_DO: routine must be indentet by 1 space from here on,
-!--                       and long lines must be wrapped
-                  IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j-1,i) ) .AND.     &
-                       ( nzb_u_outer(j,i) == nzb_u_outer(j+1,i) ) )  THEN
-                     inc        = -1                 
-                     wall_index =  j + 1
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_u_l(k,j,2) = inc * lc
-                     logc_ratio_u_l(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-
-!
-!--               Wall for w on the south side, but not on the north side.
-                  i  = -1
-                  IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j+1,i) )  .AND.    &
-                       ( nzb_w_outer(j,i) == nzb_w_outer(j-1,i) ) )  THEN
-                     inc        =  1
-                     wall_index =  j 
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_w_l(k,j,2) = inc * lc
-                     logc_ratio_w_l(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-
-!
-!--               Wall for w on the north side, but not on the south side.
-                  i  = -1
-                  IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j-1,i) ) .AND.     &
-                       ( nzb_w_outer(j,i) == nzb_w_outer(j+1,i) ) )  THEN
-                     inc        = -1
-                     wall_index =  j+1 
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_w_l(k,j,2) = inc * lc
-                     logc_ratio_w_l(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-               ENDDO
-            ENDDO
-         ENDIF   !  IF ( nest_bound_l )
+                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j-1,i) ) .AND.        &
+                        ( nzb_u_outer(j,i) == nzb_u_outer(j+1,i) ) )  THEN
+                      inc        = -1
+                      wall_index =  j + 1
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_u_l(k,j,2) = inc * lc
+                      logc_ratio_u_l(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+!
+!--                Wall for w on the south side, but not on the north side.
+                   i  = -1
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j+1,i) )  .AND.       &
+                        ( nzb_w_outer(j,i) == nzb_w_outer(j-1,i) ) )  THEN
+                      inc        =  1
+                      wall_index =  j
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_w_l(k,j,2) = inc * lc
+                      logc_ratio_w_l(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+!
+!--                Wall for w on the north side, but not on the south side.
+                   i  = -1
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j-1,i) )  .AND.       &
+                        ( nzb_w_outer(j,i) == nzb_w_outer(j+1,i) ) )  THEN
+                      inc        = -1
+                      wall_index =  j+1
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_w_l(k,j,2) = inc * lc
+                      logc_ratio_w_l(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+                ENDDO
+             ENDDO
+
+          ENDIF   !  IF ( nest_bound_l )
 
 !        
-!--      Right boundary.
-         IF ( nest_bound_r )  THEN
-            ALLOCATE( logc_w_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2) )
-            ALLOCATE( logc_ratio_w_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2,0:ncorr-1) )
-            logc_w_r       = 0
-            logc_ratio_w_r = 1.0_wp
-            direction      = 2
-            i  = nxr + 1        
-            DO  j = nys, nyn
-               DO  k = nzb, nzt_topo_nestbc_r
-
-!
-!--               Wall for u on the south side, but not on the north side.
-                  IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j+1,i) )  .AND.    &
-                       ( nzb_u_outer(j,i) == nzb_u_outer(j-1,i) ) )  THEN
-                     inc        = 1
-                     wall_index = j 
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_u_r(k,j,2) = inc * lc
-                     logc_ratio_u_r(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-
-!
-!--               Wall for u on the north side, but not on the south side.
-                  IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j-1,i) )  .AND.    &
-                       ( nzb_u_outer(j,i) == nzb_u_outer(j+1,i) ) )  THEN
-                     inc        = -1                 
-                     wall_index =  j+1
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_u_r(k,j,2) = inc * lc
-                     logc_ratio_u_r(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-
-!
-!--               Wall for w on the south side, but not on the north side.
-                  IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j+1,i) )  .AND.    &
-                       ( nzb_w_outer(j,i) == nzb_w_outer(j-1,i) ) )  THEN
-                     inc        =  1
-                     wall_index =  j 
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_w_r(k,j,2) = inc * lc
-                     logc_ratio_w_r(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-!
-!--               Wall for w on the north side, but not on the south side.
-                  IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j-1,i) ) .AND.     &
-                       ( nzb_w_outer(j,i) == nzb_w_outer(j+1,i) ) )  THEN
-                     inc        = -1
-                     wall_index =  j+1 
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element.
-                     logc_w_r(k,j,2) = inc * lc
-                     logc_ratio_w_r(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-               ENDDO
-            ENDDO
-         ENDIF   !  IF ( nest_bound_r )
+!--       Right boundary
+          IF ( nest_bound_r )  THEN
+
+             ALLOCATE( logc_w_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2) )
+             ALLOCATE( logc_ratio_w_r(nzb:nzt_topo_nestbc_r,nys:nyn,1:2,       &
+                                      0:ncorr-1) )
+             logc_w_r       = 0
+             logc_ratio_w_r = 1.0_wp
+             direction      = 2
+             i  = nxr + 1
+
+             DO  j = nys, nyn
+                DO  k = nzb, nzt_topo_nestbc_r
+!
+!--                Wall for u on the south side, but not on the north side
+                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j+1,i) )  .AND.       &
+                        ( nzb_u_outer(j,i) == nzb_u_outer(j-1,i) ) )  THEN
+                      inc        = 1
+                      wall_index = j
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_u_r(k,j,2) = inc * lc
+                      logc_ratio_u_r(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+!
+!--                Wall for u on the north side, but not on the south side
+                   IF ( ( nzb_u_outer(j,i) > nzb_u_outer(j-1,i) )  .AND.       &
+                        ( nzb_u_outer(j,i) == nzb_u_outer(j+1,i) ) )  THEN
+                      inc        = -1
+                      wall_index =  j+1
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_u_r(k,j,2) = inc * lc
+                      logc_ratio_u_r(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+!
+!--                Wall for w on the south side, but not on the north side
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j+1,i) )  .AND.       &
+                        ( nzb_w_outer(j,i) == nzb_w_outer(j-1,i) ) )  THEN
+                      inc        =  1
+                      wall_index =  j
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_w_r(k,j,2) = inc * lc
+                      logc_ratio_w_r(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+!
+!--                Wall for w on the north side, but not on the south side
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j-1,i) )  .AND.       &
+                        ( nzb_w_outer(j,i) == nzb_w_outer(j+1,i) ) )  THEN
+                      inc        = -1
+                      wall_index =  j+1
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, j, inc, wall_index, z0(j,i), kb, direction, ncorr )
+
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_w_r(k,j,2) = inc * lc
+                      logc_ratio_w_r(k,j,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+                ENDDO
+             ENDDO
+
+          ENDIF   !  IF ( nest_bound_r )
 
 !        
-!--      South boundary.
-         IF ( nest_bound_s )  THEN
-            ALLOCATE( logc_w_s(nzb:nzt_topo_nestbc_s, nxl:nxr, 1:2) )
-            ALLOCATE( logc_ratio_w_s(nzb:nzt_topo_nestbc_s, nxl:nxr, 1:2, 0:ncorr-1) )
-            logc_w_s       = 0
-            logc_ratio_w_s = 1.0_wp  
-            direction      = 3
-            DO  i = nxl, nxr
-               DO  k = nzb, nzt_topo_nestbc_s
-
-!
-!--               Wall for v on the left side, but not on the right side.
-                  j  = 0
-                  IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i+1) )  .AND.    &
-                       ( nzb_v_outer(j,i) == nzb_v_outer(j,i-1) ) )  THEN
-                     inc        =  1
-                     wall_index =  i 
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_v_s(k,i,2) = inc * lc
-                     logc_ratio_v_s(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-!
-!--               Wall for v on the right side, but not on the left side.
-                  j  = 0
-                  IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i-1) )  .AND.    &
-                       ( nzb_v_outer(j,i) == nzb_v_outer(j,i+1) ) )  THEN
-                     inc        = -1
-                     wall_index =  i+1
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_v_s(k,i,2) = inc * lc
-                     logc_ratio_v_s(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-
-!
-!--               Wall for w on the left side, but not on the right side.
-                  j  = -1
-                  IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i+1) )  .AND.    &
-                       ( nzb_w_outer(j,i) == nzb_w_outer(j,i-1) ) )  THEN
-                     inc        =  1
-                     wall_index =  i
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_w_s(k,i,2) = inc * lc
-                     logc_ratio_w_s(k,i,2,0:ncorr - 1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-
-!
-!--               Wall for w on the right side, but not on the left side.
-                  j  = -1
-                  IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i-1) )  .AND.    &
-                       ( nzb_w_outer(j,i) == nzb_w_outer(j,i+1) ) )  THEN
-                     inc        = -1
-                     wall_index =  i+1 
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_w_s(k,i,2) = inc * lc
-                     logc_ratio_w_s(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-               ENDDO
-            ENDDO
-         ENDIF   !  IF (nest_bound_s )
+!--       South boundary
+          IF ( nest_bound_s )  THEN
+
+             ALLOCATE( logc_w_s(nzb:nzt_topo_nestbc_s, nxl:nxr, 1:2) )
+             ALLOCATE( logc_ratio_w_s(nzb:nzt_topo_nestbc_s,nxl:nxr,1:2,       &
+                                      0:ncorr-1) )
+             logc_w_s       = 0
+             logc_ratio_w_s = 1.0_wp
+             direction      = 3
+
+             DO  i = nxl, nxr
+                DO  k = nzb, nzt_topo_nestbc_s
+!
+!--                Wall for v on the left side, but not on the right side
+                   j  = 0
+                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i+1) )  .AND.       &
+                        ( nzb_v_outer(j,i) == nzb_v_outer(j,i-1) ) )  THEN
+                      inc        =  1
+                      wall_index =  i
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_v_s(k,i,2) = inc * lc
+                      logc_ratio_v_s(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+!
+!--                Wall for v on the right side, but not on the left side
+                   j  = 0
+                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i-1) )  .AND.       &
+                        ( nzb_v_outer(j,i) == nzb_v_outer(j,i+1) ) )  THEN
+                      inc        = -1
+                      wall_index =  i+1
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_v_s(k,i,2) = inc * lc
+                      logc_ratio_v_s(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+!
+!--                Wall for w on the left side, but not on the right side
+                   j  = -1
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i+1) )  .AND.       &
+                        ( nzb_w_outer(j,i) == nzb_w_outer(j,i-1) ) )  THEN
+                      inc        =  1
+                      wall_index =  i
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_w_s(k,i,2) = inc * lc
+                      logc_ratio_w_s(k,i,2,0:ncorr - 1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+!
+!--                Wall for w on the right side, but not on the left side
+                   j  = -1
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i-1) )  .AND.       &
+                        ( nzb_w_outer(j,i) == nzb_w_outer(j,i+1) ) )  THEN
+                      inc        = -1
+                      wall_index =  i+1
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_w_s(k,i,2) = inc * lc
+                      logc_ratio_w_s(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+                ENDDO
+             ENDDO
+
+          ENDIF   !  IF (nest_bound_s )
 
 !        
-!--      North boundary.
-         IF ( nest_bound_n )  THEN
-            ALLOCATE( logc_w_n(nzb:nzt_topo_nestbc_n, nxl:nxr, 1:2) )
-            ALLOCATE( logc_ratio_w_n(nzb:nzt_topo_nestbc_n, nxl:nxr, 1:2, 0:ncorr-1) )
-            logc_w_n       = 0
-            logc_ratio_w_n = 1.0_wp
-            direction      = 3
-            j  = nyn + 1
-            DO  i = nxl, nxr
-               DO  k = nzb, nzt_topo_nestbc_n
-
-!
-!--               Wall for v on the left side, but not on the right side.
-                  IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i+1) )  .AND.    &
-                       ( nzb_v_outer(j,i) == nzb_v_outer(j,i-1) ) )  THEN
-                     inc        = 1
-                     wall_index = i 
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_v_n(k,i,2) = inc * lc
-                     logc_ratio_v_n(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-
-!
-!--               Wall for v on the right side, but not on the left side.
-                  IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i-1) )  .AND.    &
-                       ( nzb_v_outer(j,i) == nzb_v_outer(j,i+1) ) )  THEN
-                     inc        = -1                 
-                     wall_index =  i + 1
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_v_n(k,i,2) = inc * lc
-                     logc_ratio_v_n(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-
-!
-!--               Wall for w on the left side, but not on the right side.
-                  IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i+1) )  .AND.    &
-                       ( nzb_w_outer(j,i) == nzb_w_outer(j,i-1) ) )  THEN
-                     inc        = 1
-                     wall_index = i
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_w_n(k,i,2) = inc * lc
-                     logc_ratio_w_n(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-
-!
-!--               Wall for w on the right side, but not on the left side.
-                  IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i-1) ) .AND.     &
-                       ( nzb_w_outer(j,i) == nzb_w_outer(j,i+1) ) )  THEN
-                     inc        = -1
-                     wall_index =  i+1 
-                     CALL pmci_define_loglaw_correction_parameters( lc, lcr, k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
-
-!
-!--                  The direction of the wall-normal index is stored as the sign of the logc-element. 
-                     logc_w_n(k,i,2) = inc * lc
-                     logc_ratio_w_n(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
-                     lcr(0:ncorr-1) = 1.0_wp
-                  ENDIF
-               ENDDO
-            ENDDO
-         ENDIF   !  IF ( nest_bound_n )
-      ENDIF   !  IF ( topography /= 'flat' )
-
-   END SUBROUTINE pmci_init_loglaw_correction
+!--       North boundary
+          IF ( nest_bound_n )  THEN
+
+             ALLOCATE( logc_w_n(nzb:nzt_topo_nestbc_n, nxl:nxr, 1:2) )
+             ALLOCATE( logc_ratio_w_n(nzb:nzt_topo_nestbc_n,nxl:nxr,1:2,       &
+                                      0:ncorr-1) )
+             logc_w_n       = 0
+             logc_ratio_w_n = 1.0_wp
+             direction      = 3
+             j  = nyn + 1
+
+             DO  i = nxl, nxr
+                DO  k = nzb, nzt_topo_nestbc_n
+!
+!--                Wall for v on the left side, but not on the right side
+                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i+1) )  .AND.       &
+                        ( nzb_v_outer(j,i) == nzb_v_outer(j,i-1) ) )  THEN
+                      inc        = 1
+                      wall_index = i
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_v_n(k,i,2) = inc * lc
+                      logc_ratio_v_n(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+!
+!--                Wall for v on the right side, but not on the left side
+                   IF ( ( nzb_v_outer(j,i) > nzb_v_outer(j,i-1) )  .AND.       &
+                        ( nzb_v_outer(j,i) == nzb_v_outer(j,i+1) ) )  THEN
+                      inc        = -1
+                      wall_index =  i + 1
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_v_n(k,i,2) = inc * lc
+                      logc_ratio_v_n(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+!
+!--                Wall for w on the left side, but not on the right side
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i+1) )  .AND.       &
+                        ( nzb_w_outer(j,i) == nzb_w_outer(j,i-1) ) )  THEN
+                      inc        = 1
+                      wall_index = i
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_w_n(k,i,2) = inc * lc
+                      logc_ratio_w_n(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+!
+!--                Wall for w on the right side, but not on the left side
+                   IF ( ( nzb_w_outer(j,i) > nzb_w_outer(j,i-1) )  .AND.       &
+                        ( nzb_w_outer(j,i) == nzb_w_outer(j,i+1) ) )  THEN
+                      inc        = -1
+                      wall_index =  i+1
+                      CALL pmci_define_loglaw_correction_parameters( lc, lcr,  &
+                          k, i, inc, wall_index, z0(j,i), kb, direction, ncorr )
+!
+!--                   The direction of the wall-normal index is stored as the
+!--                   sign of the logc-element.
+                      logc_w_n(k,i,2) = inc * lc
+                      logc_ratio_w_n(k,i,2,0:ncorr-1) = lcr(0:ncorr-1)
+                      lcr(0:ncorr-1) = 1.0_wp
+                   ENDIF
+
+                ENDDO
+             ENDDO
+
+          ENDIF   !  IF ( nest_bound_n )
+
+       ENDIF   !  IF ( topography /= 'flat' )
+
+    END SUBROUTINE pmci_init_loglaw_correction
 
 
